function main()
{
  var app = System.GetInterface('Application');
  var Model = app.Models.GetObject(0);
  var WorkSpaceMain = Model.Workspaces.GetObject(0);
  var i, j, r, User, WorkSpace, Object, Relation;
  var ChildEntity, ParentEntity, WLine;

  Model.Lock();
  for (i=0; i<Model.Users.Count; i++)
  {
    User = Model.Users.GetObject(i);
    WorkSpace = Model.CreateNewObject( 2501 ); //Create new workspace
    WorkSpace.Name = User.Name;
    for(j=0;j<User.Objects.Count;j++)
    {
      Object = User.Objects.GetObject(j);
      if (Object.ObjectType == 2002) //Entity
      {
        CreateCopyShape(WorkSpaceMain, WorkSpace, Object, 2502); //ShapeEntity
        for (r=0; r<Object.Relations.Count; r++)
        {  
           Relation = Object.Relations.GetObject(r); 
           ChildEntity  = Relation.ChildEntity;
           ParentEntity  = Relation.ParentEntity;
           WLine = WorkSpace.CreateWorkspaceLineByParentobject(Relation, 2504); //Create Relation line
           if (WLine != null)
             WLine.FontSize = 8; //patch of TDM bug
        }
      }
      else
        if (Object.ObjectType == 2005) //View
        {
          CreateCopyShape(WorkSpaceMain, WorkSpace, Object, 2503); //ShapeView
        }
        else
          if (Object.ObjectType == 2035) //MaterializedView
          {
            CreateCopyShape(WorkSpaceMain, WorkSpace, Object, 2506); //ShapeMaterializedView
          } 
    }
  }
  Model.UnLock();
}

function CreateCopyShape(WorkSpaceMain, WorkSpace, Object, WSType)
{
  var k, ObjectShape, MainObjectShape;

  ObjectShape = WorkSpace.NewWorkSpaceShape(WSType, Object);
  for (k=0; k<WorkSpaceMain.ShapeList.Count; k++)
  {
    MainObjectShape = WorkSpaceMain.ShapeList.GetObject(k);
    if ( (MainObjectShape.ObjectType == WSType)
      && (MainObjectShape.ParentBaseID == ObjectShape.ParentBaseID) )
    {
      ObjectShape.Left = MainObjectShape.Left;
      ObjectShape.Top = MainObjectShape.Top;
      ObjectShape.Width = MainObjectShape.Width;
      ObjectShape.Height = MainObjectShape.Height;
      break;
    }
  }
}
